unit FileDialog;

{Copyright Net Services 1999}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Commdlg;

type
  TFileDialog = class(TOpenDialog)
  procedure WMNotify(var Message: TWMNotify); message WM_NOTIFY;
  private
    { Private declarations }
    FOldCaption:string;
    FNewCaption:string;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent);override;
  published
    { Published declarations }
    property OldCaption:string read FOldCaption write FOldCaption;
    property NewCaption:string read FNewCaption write FNewCaption;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TFileDialog]);
end;

constructor TFileDialog.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  FOldCaption := '&Open';
  FNewCaption := 'Your Choice!';
end;

procedure TFileDialog.WMNotify(var Message: TWMNotify);
var
   h, l:integer;
   ButtonText:string;
begin
     Application.ProcessMessages;

     if Message.NMHdr.code=CDN_INITDONE then
     begin
       h := GetWindow(Handle, GW_HWNDFIRST);
       while h<>0 do
       begin
         h := GetWindow(h, GW_HWNDNEXT);
         setLength(ButtonText,33);
         l := GetWindowText(h, PChar(ButtonText),32);
         ButtonText := Copy(ButtonText,1,l);
         if ButtonText=FOldCaption then
         begin
           ButtonText := FNewCaption;
           SetWindowText(h,PChar(ButtonText));
           h:=0;
         end;
       end;
     end;
     {relay message on}
     Message.Result := SendMessage(Message.NMHdr.hwndFrom, WM_NOTIFY, Message.NMHdr.idFrom, Integer(Pointer(Message.NMHdr)));
end;
end.
